﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using System.ComponentModel;
using System.Collections.ObjectModel;

namespace GridSample
{
    public partial class MainPage : UserControl
    {
        public MainPage()
        {
            InitializeComponent();
            this.DataContext = new ObservableCollection<Person>()
            {
                new Person(){FirstName = "John", LastName="Doe"},
                new Person(){FirstName = "John", LastName="Smith"},
                new Person(){FirstName = "Mark", LastName="Green"}
            };
        }
    }

    public class Person : INotifyPropertyChanged
    {
        private string _firstName;

        public string FirstName
        {
            get { return this._firstName; }
            set
            {
                if (this._firstName != value)
                {
                    this._firstName = value;
                    this.RaisePropertyChanged("FirstName");
                }
            }
        }

        private string _lastName;

        public string LastName
        {
            get { return this._lastName; }
            set
            {
                if (this._lastName != value)
                {
                    this._lastName = value;
                    this.RaisePropertyChanged("LastName");
                }
            }
        }


        #region INotifyPropertyChanged Members

        protected void RaisePropertyChanged(string propertyName)
        {
            var handler = this.PropertyChanged;
            if (handler != null)
            {
                handler(this, new PropertyChangedEventArgs(propertyName));
            }
        }
        public event PropertyChangedEventHandler PropertyChanged;

        #endregion //INotifyPropertyChanged Members
    }

}
